module OrientDb
  class InstitutionRepository < Base
    include OrientDb::Methods::EdgeMethods

    def create(institution)
      institution = connection.command sprintf("INSERT INTO Institution (name, created_at, last_modified, country, city, description, thumbnail, address) VALUES ('%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s')",
        institution.name, Time.now, Time.now, institution.country, institution.city, institution.description, institution.thumbnail, institution.address )

      find(institution["result"][0]["@rid"]) || false
    end

    def find_by_name(name)
      result = select_by_property(odb_class, "name", name)
      build_object result.first
    end

    # return associated objects
    #
    # if receive user, return associated institutions
    # if receive institution, return associated users
    # else return nil
    #
    def associated_with(object)
      return InstitutionBuilder.build get_edges_end('BelongsTo', 'out', object.rid) if object.class == User
      return User.find(get_edges_end('BelongsTo', 'in', object.id).map{|user| user['p_id']}) if object.class == Institution
      return nil
    end

    def add_user(user, institution)
      unless edge_exists? "BelongsTo", user.rid, institution.id
        create_edge "BelongsTo", user.rid, institution.id
      end

      institution
    end

    def remove_user(user, institution)
      if edge_exists? "BelongsTo", user.rid, institution.id
        destroy_edge "BelongsTo", user.rid, institution.id
      end
    end

    def build_object(args={})
      InstitutionBuilder.build_from_orientdb args
    end

    private

    def odb_class
      "Institution"
    end

  end
end
